﻿namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    static async Task Main()
    {
        string clovaStudioAPIKey = "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"; // X-NCP-CLOVASTUDIO-API-KEY
        string apiGatewayAPIKey  = "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX";                         // X-NCP-APIGW-API-KEY

        using APIClient client = new APIClient(clovaStudioAPIKey, apiGatewayAPIKey);

        List<Message> messageList =
        [
            new Message { Role = "system", Content = "당신은 서울 관광 전문 가이드 입니다."     },
            new Message { Role = "user"  , Content = "서울 북촌에 있는 맛집을 3곳 추천해주세요."}
        ];

        RequestMessage request = new RequestMessage();

        request.MessageList       = messageList;
        request.TopP              = 0.8d;
        request.TopK              = 0;
        request.MaximumTokenCount = 256;
        request.Temperature       = 0.5d;
        request.RepeatPenalty     = 5.0d;
        request.StopBefore        = new List<string>();
        request.IncludeAIFilters  = true;
        request.Seed              = 0;

        ResponseMessage responseMessage = await client.RequestChat(request);

        Console.WriteLine(responseMessage.Result.Message.Content);
    }

    #endregion
}